﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Ribbon.Internal;
using Infragistics.Windows.Ribbon;

namespace XamRibbonWindowsFormsHost
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
       
    }

    public partial class ButtonToolProxy : RibbonToolProxy<ButtonTool>
    {
        public ButtonToolProxy()
            : base()
        {
        }
    }

    public partial class ButtonTool : Button, IRibbonTool
    {
        static ButtonTool()
        {
            RibbonGroup.MaximumSizeProperty.OverrideMetadata(typeof(ButtonTool),
             new FrameworkPropertyMetadata(RibbonToolSizingMode.ImageAndTextNormal));
        }

        #region Common Tool Properties

        #region Id

        /// <summary>
        /// Identifies the Id dependency property.
        /// </summary>
        /// <seealso cref="Id"/>
        public static readonly DependencyProperty IdProperty = RibbonToolHelper.IdProperty.AddOwner(typeof(ButtonTool));

        /// <summary>
        /// Returns/sets the Id associated with the tool.
        /// </summary>
        /// <seealso cref="IdProperty"/>
        [System.ComponentModel.Bindable(true)]
        public string Id
        {
            get
            {
                return (string)this.GetValue(ButtonTool.IdProperty);
            }
            set
            {
                this.SetValue(ButtonTool.IdProperty, value);
            }
        }

        #endregion //Id

        #endregion //Common Tool Properties

        #region IRibbonTool Members

        public Infragistics.Windows.Ribbon.Internal.RibbonToolProxy ToolProxy
        {
            get
            {
                //throw new Exception("The method or operation is not implemented.");
                return new ButtonToolProxy();
            }
        }

        #endregion
    }
}
